
macro .code {section '.code' code readable executable}
macro .end arg {entry arg
include 'include\win32Api.inc'}

macro Application.initialized
{	invoke	InitCommonControls}

macro Application.createform form, proc
{
	local align.center
	local create.form

	invoke	GetModuleHandle,0
	mov	[hinstance],eax
	invoke	LoadIcon,eax,1
	mov	[wc.hIcon],eax
	invoke	LoadCursor,0,IDC_ARROW
	mov	[wc.hCursor],eax
	mov	[wc.style],0
	mov	[wc.lpfnWndProc], proc
	mov	[wc.cbClsExtra],0
	mov	[wc.cbWndExtra],0
	mov	eax,[hinstance]
	mov	[wc.hInstance],eax
	mov	[wc.hbrBackground], COLOR_BTNFACE+1
	mov	[wc.lpszMenuName],0
	mov	[wc.lpszClassName],class.#form
	invoke	RegisterClass,wc

      align.center:
	invoke	GetSystemMetrics,SM_CXSCREEN
	mov	ecx, eax
	shr	ecx, 1
	mov	eax, [rc.right]
	shr	eax, 1
	sub	ecx, eax
	mov	[rc.left], ecx
	invoke	GetSystemMetrics,SM_CYSCREEN
	mov	ecx, eax
	shr	ecx, 2
	mov	eax, [rc.bottom]
	shr	eax, 1
	sub	ecx, eax
	mov	[rc.top], ecx

      create.form:
	invoke	CreateWindowEx,0,class.#form,title.#form,WS_VISIBLE+WS_OVERLAPPEDWINDOW,\
			      [rc.left],[rc.top],[rc.right],[rc.bottom],0,0,[hinstance],0
	mov	[hform], eax}

macro Application.run
{
  local msg_loop
  local end_loop
  msg_loop:
	invoke	GetMessage,msg,NULL,0,0
	or	eax,eax
	jz	end_loop
	invoke	TranslateMessage,msg
	invoke	DispatchMessage,msg
	jmp	msg_loop
  end_loop:
}

macro Application.destroy {invoke ExitProcess,0}
